<?php

/*
 * Model layer of the BotchaForm objects.
 */
class BotchaFormModel {

  protected static $forms;

  public static function getForms($parameters = array()) {
    $forms = db_select('botcha_form', 'bf')
      ->fields('bf');
    if (!empty($parameters['forms'])) {
      foreach ((array) $parameters['forms'] as $form_id) {
        $forms->condition('id', $form_id, 'IN');
      }
    }
    $result = $forms->execute()->fetchAllAssoc('id');
    return $result;
  }

  public static function getForm($id) {
    //if (empty(self::$forms[$id])) {
      self::$forms = self::getForms();
    //}
    return !empty(self::$forms[$id]) ? (self::$forms[$id]) : NULL;
  }

  /**
   * Save form to the database.
   * @param BotchaForm $form
   */
  public static function save($form) {
    // Save form.
    $forms = db_select('botcha_form', 'bf')
      ->fields('bf')
      ->condition('id', $form->id)
      ->execute()
      ->fetchCol();
    if (!count($forms)) {
      db_insert('botcha_form')
        ->fields(array('id' => $form->id))
        ->execute();
    }
    $recipebook = $form->getRecipebook();
    // Save form-recipe book relationship.
    db_merge('botcha_recipebook_form')
      ->key(array('form_id' => $form->id))
      ->fields(array(
        'rbid' => $recipebook->id,
      ))->execute();
    self::$forms[$form->id] = $form->id;
  }

  public static function delete($form) {
    // Delete all data related to this form.
    db_delete('botcha_recipebook_form')
      ->condition('form_id', $form->id)
      ->execute();
    db_delete('botcha_form')
      ->condition('id', $form->id)
      ->execute();
    unset(self::$forms[$form->id]);
  }
}
