<?php

/*
 * Model layer of the BotchaRecipe objects.
 */
class BotchaRecipeModel {

  protected static $recipes;

  public static function getRecipes($parameters = NULL) {
    $recipes = db_select('botcha_recipe', 'br')
      ->fields('br');
    if (!empty($parameters['recipes'])) {
      foreach ((array)$parameters['recipes'] as $recipe_id) {
        $recipes->condition('id', $recipe_id, 'IN');
      }
    }
    return $recipes->execute()->fetchAllAssoc('id');
  }

  public static function getRecipe($id) {
    if (empty(self::$recipes[$id])) {
      // Just to ensure that this element of an array is set.
      self::$recipes[$id] = NULL;
      self::$recipes = self::getRecipes();
    }
    return self::$recipes[$id];
  }

  function save($recipe) {
    // Save recipe to DB.
    db_merge('botcha_recipe')
      ->fields(array('id', 'classname', 'title', 'description'))
      ->values(array(
        'id' => $this->id,
        'classname' => $this->classname,
        'title' => $this->title,
        'description' => $this->description,
      ))->execute();
  }
}
